//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern double Period1     =  25;
extern double Period2     =  13;
extern double Period3     =   1;
extern int    Price       = PRICE_CLOSE;
extern double EmaPeriod   =  9;
extern double EmaSmooth   =  9;
extern double EmaPrice    = PRICE_CLOSE;
extern int    TsiLookBack = 10;
extern int    EmaLookBack = 10;

double sdt[];
double tsi[];
double ema[];
double histu[];
double histd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,histu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,histd); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,sdt);
   SetIndexBuffer(3,tsi);
   SetIndexBuffer(4,ema);
   return(0);
}
int deinit()
{
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double price     = iMA(NULL,0,1,0,MODE_SMA,EmaPrice,i);
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
         double avg = iEma(iEma(iEma(        priceDiff ,Period1,i,0),Period2,i,1),Period3,i,2);
         double ava = iEma(iEma(iEma(MathAbs(priceDiff),Period1,i,3),Period2,i,4),Period3,i,5);
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
                  ema[i] = iEma(iEma(price,EmaPeriod,i,6),EmaSmooth,i,7);
                  
         //
         //
         //
         //
         //
         
         double slope1 = tsi[i]-tsi[i+TsiLookBack];
         double slope2 = ema[i]-ema[i+EmaLookBack];
         double posTsi = 0;
         double negTsi = 0;
            if (slope1>0 && slope2>0) posTsi = tsi[i];
            if (slope1<0 && slope2<0) negTsi = tsi[i];
         sdt[i]   = posTsi + negTsi;
         histu[i] = EMPTY_VALUE;
         histd[i] = EMPTY_VALUE;
            if (sdt[i] > 0) histu[i] = sdt[i];
            if (sdt[i] < 0) histd[i] = sdt[i];
      }
      return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][8];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}